/* =========================================================================

NAME: place-n-fit.js

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 08.04.2004 15:00

COMMENT:
Script search file names in the active document and place file into parent textframe

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
with (app) {
// ini 
	var iniFile = new File (activeScript.path+ "/place-n-Fit.ini");
	if (iniFile.exists) {
		eval ("//@include \'place-n-Fit.ini\';");
	} else {
		alert("Can\'t open ini file!");
		exit();
	}
// lang 
	var myLangFile = new File (activeScript.path + "/" + iniLangFile);
	if (myLangFile.exists) {
		eval ("//@include \'" + iniLangFile + "\';");
	} else {
		alert ("Cant open lang file!");
		exit();
	}
//  
	if (documents.length < 1) {
		alert(langNoDoc);
		exit();
	}
// 
	var myDialog = dialogs.add({name:iniScriptName + " " + iniScriptVersion});
		with (myDialog.dialogColumns.add()) {
			with(dialogRows.add()) {
				with(dialogColumns.add()) {
					with(borderPanels.add().dialogColumns.add()) {
						dialogRows.add().staticTexts.add({staticLabel:langFindOptions});
						var mySelectNameOptions = dialogRows.add().radiobuttonGroups.add();
						with(mySelectNameOptions) {
							radiobuttonControls.add({staticLabel:langShortName, checkedState:iniShortNames});
							radiobuttonControls.add({staticLabel:langLongName, checkedState:iniLongNames});
						}
						var mySelectionURI = dialogRows.add().checkboxControls.add({staticLabel:langURIEncode, checkedState:iniURI});
					}
				}
				with(dialogColumns.add()) {
					with(borderPanels.add().dialogColumns.add()) {
						dialogRows.add().staticTexts.add({staticLabel:langPlaceOptions});
						var mySelectUsePermDir = dialogRows.add().checkboxControls.add({staticLabel:langUsePermanentDir, checkedState:iniUsePermDir});
						dialogRows.add().staticTexts.add({staticLabel:langFitOptions});
						var mySelectFitOptions = dialogRows.add().dropdowns.add({stringList:langFitArray, selectedIndex:iniFitOpt});
					}				
				}
			}
			dialogRows.add().staticTexts.add({staticLabel:"\u00A9 Oleg Butrin \u2022 http://indesign.rudtp.ru"});
		}
// 
	var myResult = myDialog.show();
	if (!myResult) {
		myDialog.destroy();
		exit();
	}
//    
	if ((mySelectUsePermDir.checkedState) && (iniPermanentDir == null)) {
		var myFolder = Folder.selectDialog(langSelectPermanentFolder);
		if (!myFolder) {
			alert(langNoFolderSelect);
			myDialog.destroy();
			exit();
		}
//        ini 
		prompt(langEditFile, '\"' + String(myFolder) + '\"');
		myDialog.destroy();
		exit();
	}
//   
	if ((mySelectUsePermDir.checkedState) && (iniPermanentDir != null)) {
		var myFolder = new Folder(iniPermanentDir);
//  
		if (!myFolder.exists) {
			alert(langNoPermDir);
			myDialog.destroy();
			exit();
		}
	}
//      
	if (!mySelectUsePermDir.checkedState) {
//  
		var myFolder = Folder.selectDialog(langSelectDir);
		if (!myFolder) {
			alert(langNoFolderSelect);
			myDialog.destroy();
			exit();
		}
	}
//  
	switch (mySelectFitOptions.selectedIndex) {
		case 0:
			var myFit = FitOptions.centerContent;
			break;
		case 1:
			var myFit = FitOptions.frameToContent;
			break;
		case 2:
			var myFit = FitOptions.proportionally;
			break;
		case 3:
			var myFit = FitOptions.contentToFrame;
			break;
	}
//  
	var myFiles = myFolder.getFiles();
	var myErrorCount = 0;
	var myFilesPalced = 0;
//  
	for (myCounter = 0; myCounter < myFiles.length; myCounter++) {
// 
		if (myFiles[myCounter].constructor.name == "File") {
//     
			if (mySelectNameOptions.selectedButton == 0) {
				if (mySelectionURI.checkedState) {
					var myFileName = myFiles[myCounter].name;
				} else {
					var myFileName = decodeURI(myFiles[myCounter].name);	
				}
			} else {
				if (mySelectionURI.checkedState) {
					var myFileName = myFiles[myCounter].fullName;
				} else {
					var myFileName = myFiles[myCounter].fsName;	
				}
			}
			myFileName = String(myFileName);
			findPreferences = null;
//   
			var myFindResult = activeDocument.search(myFileName, undefined, iniCaseSensitive);
			if (myFindResult.length > 0) {
				myFindResult.reverse();
				var myName = decodeURI(myFiles[myCounter]);
//   
				for (myCounter = 0; myCounter < myFindResult.length; myCounter++) {
//      
					var myTextFrame = myFindResult[myCounter].parentTextFrame;
					if ((myTextFrame.contents.length < myFindResult[myCounter].contents.length + iniLuft) && (myTextFrame.contentType != ContentType.graphicType)) {
						try {
//    
							myTextFrame.place(File(myName));
							myTextFrame.fit(myFit);
							if (iniSmartFit) {
								myTextFrame.fit(FitOptions.frameToContent);
							}
							myFilesPalced++;
						} catch (error) {
							myErrorCount++
						}
					}
				}
			}
		}
	}
	findPreferences = null;
// 
	if (iniShowResult) {
		alert(langPlaced + " " + String(myFilesPalced) + " " + langFilesWith + " " + String(myErrorCount) + " " + langErrors);
	}
	myDialog.destroy();
	exit();
}